unit MainForm;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, StdCtrls, ExtCtrls, Buttons,
	Lusbapi;

const
	// -  
	CHANNELS_QUANTITY : WORD = 16;

type

	TShortrArray	= array [0..31] of Short;
	TDoubleArray	= array [0..31] of Double;
	TEditArray		= array [0..31] of TEdit;

	TForm1 = class(TForm)
		DACEd: TEdit;
		ADCEd1: TEdit;
		Label1: TLabel;
		ADCEd2: TEdit;
		ADCEd3: TEdit;
		ADCEd4: TEdit;
		ADCEd5: TEdit;
		ADCEd6: TEdit;
		ADCEd7: TEdit;
		ADCEd8: TEdit;
		ADCEd9: TEdit;
		ADCEd10: TEdit;
		ADCEd11: TEdit;
		ADCEd12: TEdit;
		ADCEd13: TEdit;
		ADCEd14: TEdit;
		ADCEd15: TEdit;
		ADCEd16: TEdit;
		Bevel1: TBevel;
		Label3: TLabel;
		Label4: TLabel;
		Label5: TLabel;
		Label6: TLabel;
		Label7: TLabel;
		Label8: TLabel;
		Label9: TLabel;
		Label10: TLabel;
		Label11: TLabel;
		Label12: TLabel;
		Label13: TLabel;
		Label14: TLabel;
		Label15: TLabel;
		Label16: TLabel;
		Label17: TLabel;
		Label18: TLabel;
		Label19: TLabel;
		Bevel2: TBevel;
		Bevel3: TBevel;
		Label2: TLabel;
		CancelBtn: TBitBtn;
		Timer1: TTimer;
		OpenLDevicePanel: TPanel;
		SlotNumberLabLabel: TLabel;
		DllVersionLabel: TLabel;
		InterfaceLabel: TLabel;
		lDllVersionLabLabel: TLabel;
		InterfaceLabLabel: TLabel;
		SlotNumberLabel: TLabel;
		procedure CancelBtnClick(Sender: TObject);
		procedure Timer1Timer(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure FormDestroy(Sender: TObject);
	private
		{ Private declarations }
	public
		{ Public declarations }

  end;

var
	//   
	Form1: TForm1;
	//   E-154
	pModule :				ILE154;
	//      
	ModuleDescription :	MODULE_DESCRIPTION_E154;
	//     
	ap :						ADC_PARS_E154;
	//       
	AdcKadrInCode :				TShortrArray;
	//      
	AdcKadrInVolt :				TDoubleArray;
	//  TEdit
	AdcSampleEditArray :	TEditArray;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
		//
	i : WORD;
begin
	//   TEdit     
	AdcSampleEditArray[0]	:= ADCEd1;
	AdcSampleEditArray[1]	:= ADCEd2;
	AdcSampleEditArray[2]	:= ADCEd3;
	AdcSampleEditArray[3]	:= ADCEd4;
	AdcSampleEditArray[4]	:= ADCEd5;
	AdcSampleEditArray[5]	:= ADCEd6;
	AdcSampleEditArray[6]	:= ADCEd7;
	AdcSampleEditArray[7]	:= ADCEd8;
	AdcSampleEditArray[8]	:= ADCEd9;
	AdcSampleEditArray[9]	:= ADCEd10;
	AdcSampleEditArray[10]	:= ADCEd11;
	AdcSampleEditArray[11]	:= ADCEd12;
	AdcSampleEditArray[12]	:= ADCEd13;
	AdcSampleEditArray[13]	:= ADCEd14;
	AdcSampleEditArray[14]	:= ADCEd15;
	AdcSampleEditArray[15]	:= ADCEd16;

	DllVersionLabel.Caption := IntToStr(GetDllVersion shr 16) +  '.' + IntToStr(GetDllVersion and $FFFF);
	pModule := nil;
	pModule := CreateLInstance(pAnsiChar('e154'));
	if pModule <> nil then	InterfaceLabel.Caption := 'OK!!!'
	else 							InterfaceLabel.Caption := 'BAD!!!';

	//    E-154   MAX_VIRTUAL_SLOTS_QUANTITY_LUSBAPI  
	for i := 0 to (MAX_VIRTUAL_SLOTS_QUANTITY_LUSBAPI-1) do if pModule.OpenLDevice(i) then break;
	// - ?
	if i = MAX_VIRTUAL_SLOTS_QUANTITY_LUSBAPI then	SlotNumberLabel.Caption := '--------'
	else 															SlotNumberLabel.Caption := IntToStr(i);

	//     
	pModule.GET_MODULE_DESCRIPTION(@ModuleDescription);

	//     
	pModule.GET_ADC_PARS(@ap);

	//     
	ap.ClkSource 				:= INT_ADC_CLOCK_E154;					//   
	ap.EnableClkOutput 		:= ADC_CLOCK_TRANS_DISABLED_E154;	//     
	ap.InputMode 				:= NO_SYNC_E154;							//    
	ap.ChannelsQuantity		:= CHANNELS_QUANTITY;					// -  
	//   
	for i:=0 to (ap.ChannelsQuantity - 1) do ap.ControlTable[i] := i or (ADC_INPUT_RANGE_5000mV_E154 shl $6);
	ap.AdcRate					:= 100.0;										//     
	ap.InterKadrDelay			:= 0.0;										//    

	//       
	pModule.SET_ADC_PARS(@ap);

end;

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
	if pModule <> nil then
	begin
		pModule.CloseLDevice();
		pModule.ReleaseLInstance();
	end;
end;

//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
procedure TForm1.CancelBtnClick(Sender: TObject);
begin
	Close;
end;

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
Var
		//
	i : WORD;
	DacSampleInV : double;
begin

	//    
	if DACEd.text <> '' then
	begin
		try
			DacSampleInV := StrToFloat(DACEd.text);

			if 5.0 < DacSampleInV			then
				begin
					DacSampleInV :=  5.0;
					DACEd.text := FloatToStr(DacSampleInV);
				end
			else if DacSampleInV < -5.0	then
				begin
					 DacSampleInV := -5.0;
					DACEd.text := FloatToStr(DacSampleInV);
				end;

		except
			on EConvertError do
				begin
					DacSampleInV := 0.0;
					DACEd.text := '';
					MessageDlg('    double!!!', mtError, [mbOK, mbCancel], 0);
				end;
		end;

		pModule.DAC_SAMPLE_VOLT(DacSampleInV, TRUE);
	end;

	//     
	pModule.ADC_KADR(@AdcKadrInCode);
	//    
	pModule.ProcessArray(@AdcKadrInCode, @AdcKadrInVolt, CHANNELS_QUANTITY, TRUE, TRUE);
	//      
	for i:=0 to (CHANNELS_QUANTITY - 1) do
		AdcSampleEditArray[i].Text	:= FormatFloat('0.000', AdcKadrInVolt[i]);
//		AdcSampleEditArray[i].Text	:= FormatFloat('0.000', 5.0 * AdcKadrInCode[i] / 2000.0);

end;

end.
